﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.IO;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;
using Microsoft.AspNetCore.Hosting;

namespace DocIO_AspNetCore_WebApplication.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHostingEnvironment _hostingEnvironment;
        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            _hostingEnvironment = hostingEnvironment;
        }
        public ActionResult Index(string button1, string Message)
        {
            if (button1 == null)
                return View();
            // Gets file path for template Word document.
            string rootPath = _hostingEnvironment.WebRootPath;
            FileStream fileStream = new FileStream(rootPath + "\\DocIO\\Template.doc", FileMode.Open);
            // Opens an existing document from file stream through constructor of WordDocument class
            WordDocument document = new WordDocument(fileStream, FormatType.Doc);
            fileStream.Dispose();
            //Performs the mail merge with field names and values.
            string[] fieldNames = new string[] { "Emp_Id", "Name", "Phone", "City" };
            string[] fieldValues = new string[] { "1001", "Peter", "+122-2222222", "London" };
            document.MailMerge.Execute(fieldNames, fieldValues);
            //Saves as DOCX and closes the WordDocument instance
            MemoryStream stream = new MemoryStream();
            document.Save(stream, FormatType.Docx);
            stream.Position = 0;
            document.Close();

            return File(stream, "application/vnd.openxmlformats-officedocument.wordprocessingml.document", "Sample.docx");
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
